## pion 5.0.7%2Bdfsg

=== src/CMakeLists.txt ===
# ---------------------------------------------------------------------
# pion:  a Boost C++ framework for building lightweight HTTP interfaces
# ---------------------------------------------------------------------
# Copyright (C) 2013 Splunk Inc.  (https://github.com/splunk/pion)
#
# Distributed under the Boost Software License, Version 1.0.
# See http://www.boost.org/LICENSE_1_0.txt
# ---------------------------------------------------------------------

cmake_minimum_required(VERSION 2.8.10 FATAL_ERROR)

set(PROJECT_NAME pion)
project(${PROJECT_NAME} CXX)

# get all *.cpp files from src to build target
file(GLOB SRC_FILES ${PROJECT_SOURCE_DIR}/*.cpp)
file(GLOB_RECURSE HDR_FILES ${PROJECT_WIDE_INCLUDE}/*.hpp)

if (NOT BUILD_SPDY)
    list(REMOVE_ITEM SRC_FILES ${PROJECT_SOURCE_DIR}/spdy_decompressor.cpp)
    list(REMOVE_ITEM SRC_FILES ${PROJECT_SOURCE_DIR}/spdy_parser.cpp)
    list(REMOVE_ITEM HDR_FILES ${PROJECT_WIDE_INCLUDE}/pion/spdy/decompressor.hpp)
    list(REMOVE_ITEM HDR_FILES ${PROJECT_WIDE_INCLUDE}/pion/spdy/parser.hpp)
    list(REMOVE_ITEM HDR_FILES ${PROJECT_WIDE_INCLUDE}/pion/spdy/types.hpp)
endif()

if(MSVC)
    if(BUILD_SHARED_LIBS)
        add_definitions(-DPION_EXPORTS -D_USRDLL)
    else()
        add_definitions(-D_LIB)
    endif()
endif()
# build target
add_library(${PROJECT_NAME} ${SRC_FILES} ${HDR_FILES})

target_link_libraries(${PROJECT_NAME} ${Boost_LIBRARIES})
if (ZLIB_FOUND)
    target_link_libraries(${PROJECT_NAME} ${ZLIB_LIBRARIES})
endif()
if (BZIP2_FOUND )
    target_link_libraries(${PROJECT_NAME} ${BZIP2_LIBRARIES})
endif()
if (OPENSSL_FOUND )
    target_link_libraries(${PROJECT_NAME} ${OPENSSL_LIBRARIES})
endif()
if (LOG4CPLUS_FOUND )
    target_link_libraries(${PROJECT_NAME} ${LOG4CPLUS_LIBRARIES})
endif()

install(TARGETS ${PROJECT_NAME}
    RUNTIME DESTINATION bin
    LIBRARY DESTINATION lib
    ARCHIVE DESTINATION lib
)

## pion 5.0.4+dfsg

=== debian/changelog ===
pion (5.0.4+dfsg-2) unstable; urgency=low

  * Fix FTBFS on big endian architectures, thanks to Aurelien Jarno
    for the patch (Closes: #728320)
  * Update to Standards-Version 3.9.5 (no changes)

 -- Roberto C. Sanchez <roberto@connexer.com>  Sat, 02 Nov 2013 14:21:58 -0400

pion (5.0.4+dfsg-1) unstable; urgency=low

  * New upstream release
  * Make libpion-dev, libpion-plugins, and libpion-plugins-dev conflict
    with their counterparts from the old package (Closes: #719771, #719772)
  * Add get-orig-source target to debian/rules

 -- Roberto C. Sanchez <roberto@connexer.com>  Mon, 23 Sep 2013 21:34:29 -0400

pion (5.0.3+dfsg-1) unstable; urgency=low

  * New upstream release

 -- Roberto C. Sanchez <roberto@connexer.com>  Sat, 03 Aug 2013 11:53:18 -0400

pion (5.0.1+dfsg-1) unstable; urgency=low

  * Acknowledge NMU, thanks to Matthias Klose
  * New upstream release (Closes: #701336, #708802)
  * Source package renamed as a result of upstream changes: pion-net -> pion
  * Binary packages renamed:
    + libpion-net-4.0 and libpion-common-4.0 -> libpion-5.0
    + libpion-net-dev and libpion-common-dev -> libpion-dev
  * Update watch file
  * Update copyright information
  * Update to Standards-Version 3.9.4 (no changes)
  * Enable compilation with hardening flags
  * Add dependencies:
    + liblog4cpp5-dev for libpion-dev (Closes: #678433) (LP: #881632)
    + libssl-dev for libpion-dev (Closes: #678435)
  * Ship headers for the plugins (LP: #1012022)

 -- Roberto C. Sanchez <roberto@connexer.com>  Sat, 06 Jul 2013 18:04:35 -0400

pion-net (4.0.7+dfsg-3.1) unstable; urgency=low

  * Non maintainer upload
  * Fix build failure with GCC 4.7. Closes: #672036.

 -- Matthias Klose <doko@debian.org>  Thu, 10 May 2012 21:59:39 +0200

pion-net (4.0.7+dfsg-3) unstable; urgency=low

  * Remove call to deprecated io_service() (Closes: #653787)

 -- Roberto C. Sanchez <roberto@connexer.com>  Mon, 09 Jan 2012 16:40:13 -0500

pion-net (4.0.7+dfsg-2) unstable; urgency=low

  * Add patch for aclocal.m4, thanks to Jakub Willk (Closes: #649124)

 -- Roberto C. Sanchez <roberto@connexer.com>  Fri, 25 Nov 2011 17:24:52 -0500

pion-net (4.0.7+dfsg-1) unstable; urgency=low

  * New upstream release

 -- Roberto C. Sanchez <roberto@connexer.com>  Fri, 30 Sep 2011 23:17:15 -0400

pion-net (4.0.5+dfsg-1) unstable; urgency=low

  * New upstream release (Closes: 632455)
  * Switch from ostream for logging to log4cpp
  * Update to Standards-Version 3.9.2 (no changes)

 -- Roberto C. Sanchez <roberto@connexer.com>  Sat, 02 Jul 2011 21:37:36 -0400

pion-net (4.0.1+dfsg-2) unstable; urgency=low

  * Stop shipping debug symbols for PionWebServer and PionHelloServer to
    prevent file conflicts when SONAME changes (Closes: #617933)

 -- Roberto C. Sanchez <roberto@connexer.com>  Sat, 12 Mar 2011 13:15:25 -0500

pion-net (4.0.1+dfsg-1) unstable; urgency=low

  * New upstream release
  * Rename packages:
    + libpion-net-3.0 -> libpion-net-4.0
    + libpion-common-3.0 -> libpion-common-4.0
  * Update copyright years in debian/copyright

 -- Roberto C. Sanchez <roberto@connexer.com>  Thu, 10 Mar 2011 18:00:18 -0500

pion-net (3.0.21+dfsg-1) unstable; urgency=low

  * New upstream release (Closes: #565061)
  * Update to Standards-Version 3.9.1 (no changes)
  * Version the -dbg packages to track the versioned runtime packages

 -- Roberto C. Sanchez <roberto@connexer.com>  Thu, 27 Jan 2011 12:21:39 -0500

pion-net (3.0.9+dfsg-1) unstable; urgency=low

  * New upstream release

 -- Roberto C. Sanchez <roberto@connexer.com>  Sat, 01 May 2010 11:36:15 -0400

pion-net (3.0.7+dfsg-1) unstable; urgency=low

  * New upstream release

 -- Roberto C. Sanchez <roberto@connexer.com>  Tue, 13 Apr 2010 08:02:40 -0400

pion-net (3.0.5+dfsg-1) unstable; urgency=low

  * New upstream release
  * Rename packages:
    + libpion-net-2.2.12 -> libpion-net-3.0
    + libpion-common-2.2.12 -> libpion-common-3.0
  * Switch to dpkg-source 3.0 (quilt) format

 -- Roberto C. Sanchez <roberto@connexer.com>  Sat, 03 Apr 2010 10:17:18 -0400

pion-net (2.2.12+dfsg-1) unstable; urgency=low

  * New upstream release
  * Rename packages:
    + libpion-net-2.2.10 -> libpion-net-2.2.12
    + libpion-common-2.2.10 -> libpion-common-2.2.12
  * Update to Standards-Version 3.8.4 (no changes)

 -- Roberto C. Sanchez <roberto@connexer.com>  Sat, 20 Feb 2010 12:47:17 -0500

pion-net (2.2.10+dfsg-1) unstable; urgency=low

  * New upstream release
  * Rename packages:
    + libpion-net-2.2.8 -> libpion-net-2.2.10
    + libpion-common-2.2.8 -> libpion-common-2.2.10

 -- Roberto C. Sanchez <roberto@connexer.com>  Mon, 25 Jan 2010 11:48:10 -0500

pion-net (2.2.8+dfsg-2) unstable; urgency=low

  * Adjust Build-Depends to remove non-existent packages (Closes: #562382)
  * Add ${misc:Depends} to the packages that lacked it (pleases lintian)
  * Use chrpath to remove hard coded rpath from binaries and libraries

 -- Roberto C. Sanchez <roberto@connexer.com>  Tue, 05 Jan 2010 20:17:04 -0500

pion-net (2.2.8+dfsg-1) unstable; urgency=low

  * New upstream release
  * Rename packages:
    + libpion-net-2.2.2 -> libpion-net-2.2.8
    + libpion-common-2.2.2 -> libpion-common-2.2.8

 -- Roberto C. Sanchez <roberto@connexer.com>  Mon, 07 Dec 2009 20:28:58 -0500

pion-net (2.2.2+dfsg-2) unstable; urgency=low

  * libpion-common-dev: Do not install duplicate lintian override 
  * libpion-net-dbg: Remove erroneous dependency on libpion-net-plugins
  * debian/rules: Add --disable-lockfree option to ./configure command

 -- Roberto C. Sanchez <roberto@connexer.com>  Mon, 12 Oct 2009 16:35:12 -0400

pion-net (2.2.2+dfsg-1) unstable; urgency=low

  * New upstream release
    + debian/patches/g++-4.4.patch: Removed, merged upstream
    + Remove --without-cpu option from configure command, as upstream now
      checks if -march=i686 works first
  * Rename packages:
    + libpion-net-2.1.8 -> libpion-net-2.2.2
    + libpion-common-2.1.8 -> libpion-common-2.2.2


=== debian/control ===
Source: pion
Priority: extra
Maintainer: Athena Capital Research <acr-debian@athenacr.com>
Uploaders: Roberto C. Sanchez <roberto@connexer.com>
Build-Depends: debhelper (>= 7), autotools-dev, autoconf, automake, libssl-dev, libboost-dev (>= 1.35), libboost-thread-dev (>= 1.35), libboost-iostreams-dev (>= 1.35), libboost-system-dev (>= 1.35), libboost-filesystem-dev (>= 1.35), libboost-signals-dev (>= 1.35), libboost-test-dev (>= 1.35), chrpath, zlib1g-dev, doxygen, perl, libbz2-dev, libxml2-dev, libpcap-dev, libtool, ruby, cmake, pkg-config, liblog4cpp5-dev
Standards-Version: 3.9.5
Section: libs
Homepage: http://pion.sourceforge.net/
Vcs-Browser: https://github.com/cloudmeter/pion
Vcs-Git: git://github.com/cloudmeter/pion.git

Package: libpion-dev
Section: libdevel
Architecture: any
Depends: libpion-5.0 (= ${binary:Version}), libpion-plugins (= ${binary:Version}), liblog4cpp5-dev, libssl-dev, ${shlibs:Depends}, ${misc:Depends} 
Conflicts: libpion-net-dev
Suggests: libpion-doc
Description: lightweight HTTP interface library - development files
 pion is not intended to implement yet another web server, but to
 provide HTTP(S) functionality to new or existing C++ applications. If
 you're looking for a full-featured server application, check out Apache
 or lighttpd. If you're working on a Boost C++ application and would just
 like to use HTTP to provide a simple user interface or interact with
 run-time data, then pion is a clean and simple solution.
 .
 Pion Network Library uses the Boost and asio libraries for multi-threading
 and asynchronous I/O. This allows servers implemented using pion to
 handle many thousands of connections simultaneously with a single physical
 server.
 .
 pion also supports server-side SSL & TLS encryption when built with
 the OpenSSL library (which the Debian package is).
 .
 This package includes the pion development files.

Package: libpion-plugins
Architecture: any
Depends: libpion-5.0 (= ${binary:Version}), ${shlibs:Depends}, ${misc:Depends}
Conflicts: libpion-net-plugins
Description: lightweight HTTP interface library - plugins
 pion is not intended to implement yet another web server, but to
 provide HTTP(S) functionality to new or existing C++ applications. If
 you're looking for a full-featured server application, check out Apache
 or lighttpd. If you're working on a Boost C++ application and would just
 like to use HTTP to provide a simple user interface or interact with
 run-time data, then pion is a clean and simple solution.
 .
 Pion Network Library uses the Boost and asio libraries for multi-threading
 and asynchronous I/O. This allows servers implemented using pion to
 handle many thousands of connections simultaneously with a single physical
 server.
 .
 pion also supports server-side SSL & TLS encryption when built with
 the OpenSSL library (which the Debian package is).
 .
 This package includes the pion plugins.

Package: libpion-5.0
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: lightweight HTTP interface library - runtime files
 pion is not intended to implement yet another web server, but to
 provide HTTP(S) functionality to new or existing C++ applications. If
 you're looking for a full-featured server application, check out Apache
 or lighttpd. If you're working on a Boost C++ application and would just
 like to use HTTP to provide a simple user interface or interact with
 run-time data, then pion is a clean and simple solution.
 .
 Pion Network Library uses the Boost and asio libraries for multi-threading
 and asynchronous I/O. This allows servers implemented using pion to
 handle many thousands of connections simultaneously with a single physical
 server.
 .
 pion also supports server-side SSL & TLS encryption when built with
 the OpenSSL library (which the Debian package is).
 .
 This package includes the pion runtime files.

Package: libpion-5.0-dbg
Section: debug
Architecture: any
Depends: libpion-5.0 (= ${binary:Version}), ${misc:Depends}
Description: lightweight HTTP interface library - debug files
 pion is not intended to implement yet another web server, but to
 provide HTTP(S) functionality to new or existing C++ applications. If
 you're looking for a full-featured server application, check out Apache
 or lighttpd. If you're working on a Boost C++ application and would just
 like to use HTTP to provide a simple user interface or interact with
 run-time data, then pion is a clean and simple solution.
 .
 Pion Network Library uses the Boost and asio libraries for multi-threading
 and asynchronous I/O. This allows servers implemented using pion to
 handle many thousands of connections simultaneously with a single physical
 server.
 .
 pion also supports server-side SSL & TLS encryption when built with
 the OpenSSL library (which the Debian package is).
 .
 This package includes the pion debug files.

Package: libpion-plugins-dbg
Section: debug
Architecture: any
Depends: libpion-plugins (= ${binary:Version}), libpion-5.0-dbg, ${misc:Depends}
Conflicts: libpion-net-plugins-dbg
Description: lightweight HTTP interface library - plugins debug files
 pion is not intended to implement yet another web server, but to
 provide HTTP(S) functionality to new or existing C++ applications. If
 you're looking for a full-featured server application, check out Apache
 or lighttpd. If you're working on a Boost C++ application and would just
 like to use HTTP to provide a simple user interface or interact with
 run-time data, then pion is a clean and simple solution.
 .
 Pion Network Library uses the Boost and asio libraries for multi-threading
 and asynchronous I/O. This allows servers implemented using pion to
 handle many thousands of connections simultaneously with a single physical
 server.
 .
 pion also supports server-side SSL & TLS encryption when built with
 the OpenSSL library (which the Debian package is).
 .
 This package includes the pion plugins debug files.

Package: libpion-doc
Section: doc
Architecture: all
Depends: ${misc:Depends}
Description: lightweight HTTP interface library - documentation
 pion is not intended to implement yet another web server, but to
 provide HTTP(S) functionality to new or existing C++ applications. If
 you're looking for a full-featured server application, check out Apache
 or lighttpd. If you're working on a Boost C++ application and would just
 like to use HTTP to provide a simple user interface or interact with
 run-time data, then pion is a clean and simple solution.
 .
 Pion Network Library uses the Boost and asio libraries for multi-threading
 and asynchronous I/O. This allows servers implemented using pion to
 handle many thousands of connections simultaneously with a single physical
 server.
 .
 pion also supports server-side SSL & TLS encryption when built with
 the OpenSSL library (which the Debian package is).
 .
 This package includes the pion documentation files.

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-
# Sample debian/rules that uses debhelper.
# This file was originally written by Joey Hess and Craig Small.
# As a special exception, when this file is copied by dh-make into a
# dh-make output file, you may use that output file without restriction.
# This special exception was added by Craig Small in version 0.37 of dh-make.

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1


# These are used for cross-compiling and for saving the configure script
# from having to guess our platform (since we know it already)
DEB_HOST_GNU_TYPE   ?= $(shell dpkg-architecture -qDEB_HOST_GNU_TYPE)
DEB_BUILD_GNU_TYPE  ?= $(shell dpkg-architecture -qDEB_BUILD_GNU_TYPE)
ifneq ($(DEB_HOST_GNU_TYPE),$(DEB_BUILD_GNU_TYPE))
CROSS= --build $(DEB_BUILD_GNU_TYPE) --host $(DEB_HOST_GNU_TYPE)
else
CROSS= --build $(DEB_BUILD_GNU_TYPE)
endif

dpkg_buildflags = DEB_LDFLAGS_MAINT_APPEND="-ldl -Wl,-z,defs -lpthread" dpkg-buildflags

config.status: configure
configure: configure-stamp
configure-stamp:
	dh_testdir
ifneq "$(wildcard /usr/share/misc/config.sub)" ""
	cp -f /usr/share/misc/config.sub config.sub
endif
ifneq "$(wildcard /usr/share/misc/config.guess)" ""
	cp -f /usr/share/misc/config.guess config.guess
endif
	./autogen.sh
	./configure $(CROSS) --prefix=/usr --mandir=\$${prefix}/share/man --infodir=\$${prefix}/share/info --enable-shared --disable-static --with-gnu-ld --with-pic --with-openssl --with-zlib --with-bzlib --with-log4cpp --disable-lockfree $(shell $(dpkg_buildflags) --export=configure)


build: build-arch build-indep
build-arch: build-stamp
build-indep: build-stamp
build-stamp: config.status
	dh_testdir
	$(MAKE) $(shell $(dpkg_buildflags) --export=configure) all
	$(MAKE) check
	touch $@

clean:
	dh_testdir
	dh_testroot
	rm -f build-stamp
	[ ! -f Makefile ] || $(MAKE) distclean
	rm -f config.sub config.guess
	dh_clean 

install: build
	dh_testdir
	dh_testroot
	dh_prep
	dh_installdirs
	$(MAKE) DESTDIR=$(CURDIR)/debian/tmp install
	install -d $(CURDIR)/debian/tmp/usr/share/lintian/overrides
	cp $(CURDIR)/debian/lintian/* $(CURDIR)/debian/tmp/usr/share/lintian/overrides/


# Build architecture-independent files here.
binary-indep: build install
	dh_testdir -i
	dh_testroot -i
	dh_installchangelogs -i ChangeLog
	dh_installdocs -i
	dh_install -i
	dh_installman -i
	dh_link -i
	dh_strip -i -k
	dh_compress -i
	dh_fixperms -i
	dh_makeshlibs -i
	dh_installdeb -i
	dh_shlibdeps -i
	dh_gencontrol -i
	dh_md5sums -i
	dh_builddeb -i

# Build architecture-dependent files here.
binary-arch: build install
	dh_testdir -a
	dh_testroot -a
	dh_installchangelogs -a ChangeLog
	dh_installdocs -a
	dh_install -a
	dh_installman -a
	dh_link -a
	dh_strip -a -k
	mv $(CURDIR)/debian/libpion-dev/usr/lib/debug/* $(CURDIR)/debian/libpion-5.0-dbg/usr/lib/debug/
	rmdir $(CURDIR)/debian/libpion-dev/usr/lib/debug/
	mv $(CURDIR)/debian/libpion-5.0/usr/lib/debug/usr/* $(CURDIR)/debian/libpion-5.0-dbg/usr/lib/debug/usr/
	rm $(CURDIR)/debian/libpion-5.0-dbg/usr/lib/debug/usr/bin/helloserver $(CURDIR)/debian/libpion-5.0-dbg/usr/lib/debug/usr/bin/piond
	rmdir $(CURDIR)/debian/libpion-5.0-dbg/usr/lib/debug/usr/bin/
	rmdir $(CURDIR)/debian/libpion-5.0/usr/lib/debug/usr/
	rmdir $(CURDIR)/debian/libpion-5.0/usr/lib/debug/
	mv $(CURDIR)/debian/libpion-plugins/usr/lib/debug/* $(CURDIR)/debian/libpion-plugins-dbg/usr/lib/debug/
	rmdir $(CURDIR)/debian/libpion-plugins/usr/lib/debug/
	cp $(CURDIR)/services/*.hpp $(CURDIR)/debian/libpion-dev/usr/include/pion/plugins/
	dh_compress -a
	dh_fixperms -a
	dh_makeshlibs -a
	dh_installdeb -a
	dh_shlibdeps -a
	dh_gencontrol -a
	dh_md5sums -a
	dh_builddeb -a

get-orig-source:
	uscan --watchfile $(CURDIR)/debian/watch.get-orig-source --verbose --force-download --no-symlink --destdir ..

binary: binary-indep binary-arch
.PHONY: build clean binary-indep binary-arch binary install

## pion 5.0.5+dfsg

=== debian/changelog ===
pion (5.0.5+dfsg-1) unstable; urgency=low

  * New upstream release

 -- Roberto C. Sanchez <roberto@connexer.com>  Tue, 11 Mar 2014 18:16:00 -0400

## pion 5.0.6+dfsg

=== debian/changelog ===
pion (5.0.6+dfsg-1build1) wily; urgency=medium

  * No-change rebuild against liblog4cpp5v5

 -- Steve Langasek <steve.langasek@ubuntu.com>  Mon, 03 Aug 2015 01:43:20 +0000

pion (5.0.6+dfsg-1) unstable; urgency=low

  * New upstream release
  * Update to Standards-Version 3.9.6 (no changes)
  * Strip -D_FORTIFY_SOURCE=2 from CPPFLAGS to prevent spurious inclusion
    in pion.pc

 -- Roberto C. Sanchez <roberto@connexer.com>  Mon, 06 Jul 2015 21:16:26 -0400

=== debian/control ===
--- 
+++ 
@@ -1,9 +1,10 @@
 Source: pion
 Priority: extra
-Maintainer: Athena Capital Research <acr-debian@athenacr.com>
+Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
+XSBC-Original-Maintainer: Athena Capital Research <acr-debian@athenacr.com>
 Uploaders: Roberto C. Sanchez <roberto@connexer.com>
 Build-Depends: debhelper (>= 7), autotools-dev, autoconf, automake, libssl-dev, libboost-dev (>= 1.35), libboost-thread-dev (>= 1.35), libboost-iostreams-dev (>= 1.35), libboost-system-dev (>= 1.35), libboost-filesystem-dev (>= 1.35), libboost-signals-dev (>= 1.35), libboost-test-dev (>= 1.35), chrpath, zlib1g-dev, doxygen, perl, libbz2-dev, libxml2-dev, libpcap-dev, libtool, ruby, cmake, pkg-config, liblog4cpp5-dev
-Standards-Version: 3.9.5
+Standards-Version: 3.9.6
 Section: libs
 Homepage: http://pion.sourceforge.net/
 Vcs-Browser: https://github.com/cloudmeter/pion

=== debian/rules ===
--- 
+++ 
@@ -20,7 +20,7 @@
 CROSS= --build $(DEB_BUILD_GNU_TYPE)
 endif
 
-dpkg_buildflags = DEB_LDFLAGS_MAINT_APPEND="-ldl -Wl,-z,defs -lpthread" dpkg-buildflags
+dpkg_buildflags = DEB_CPPFLAGS_MAINT_STRIP="-D_FORTIFY_SOURCE=2" DEB_LDFLAGS_MAINT_APPEND="-ldl -Wl,-z,defs -lpthread" dpkg-buildflags
 
 config.status: configure
 configure: configure-stamp

=== debian/watch ===
version=3

opts="dversionmangle=s/\+dfsg//" http://sf.net/pion/pion-(.*)\.tar\.gz debian debian/repack.sh

## pion 5.0.7%2Bdfsg

=== debian/rules ===
#!/usr/bin/make -f
# See debhelper(7) (uncomment to enable)
# output every command that modifies files on the build system.
#DH_VERBOSE = 1

# see EXAMPLES in dpkg-buildflags(1) and read /usr/share/dpkg/*
DPKG_EXPORT_BUILDFLAGS = 1
include /usr/share/dpkg/default.mk

# see FEATURE AREAS in dpkg-buildflags(1)
export DEB_BUILD_MAINT_OPTIONS = hardening=+all

# see ENVIRONMENT in dpkg-buildflags(1)
# package maintainers to append CFLAGS
#export DEB_CFLAGS_MAINT_APPEND  = -Wall -pedantic
# package maintainers to append LDFLAGS
#export DEB_LDFLAGS_MAINT_APPEND = -Wl,--as-needed

#export DEB_CPPFLAGS_MAINT_STRIP = -D_FORTIFY_SOURCE=2
export DEB_LDFLAGS_MAINT_APPEND = -ldl -Wl,-z,defs -lpthread

export DPKG_GENSYMBOLS_CHECK_LEVEL=4

# Prevent autoreconf from trashing the build:
# Pion's config.hpp.in isn't meant to be processed with autoheader
export AUTOHEADER=/bin/true

DEB_BUILD_GNU_TYPE ?= $(shell dpkg-architecture -qDEB_BUILD_GNU_TYPE)

# main packaging script based on dh7 syntax
%:
	dh $@ --with autoreconf

override_dh_auto_configure:
	dh_auto_configure -- \
	--prefix=/usr --mandir=\$${prefix}/share/man --infodir=\$${prefix}/share/info --enable-shared --disable-static --with-gnu-ld --with-pic --with-openssl --with-zlib --with-bzlib --with-log4cpp
ifeq (aarch64-linux-gnu,$(DEB_BUILD_GNU_TYPE))
	# Build tests unoptimized on arm64; building optimized on arm64 causes a failure
	sed -i 's/O2/O0/g' tests/Makefile tests/plugins/Makefile
endif

override_dh_auto_build:
	dh_auto_build
	make docs
	# We don't want upstream embedding jquery, which we will link later
	rm -f $(CURDIR)/doc/html/jquery.js

override_dh_auto_install-arch:
	dh_auto_install
	cp $(CURDIR)/services/*.hpp $(CURDIR)/debian/libpion-dev/usr/include/pion/plugins/

override_dh_auto_clean:
	dh_auto_clean
	rm -rf doc/html doc/pion-net.tag

override_dh_strip:
	dh_strip --dbgsym-migration='libpion-5.0-dbg (<< 5.0.7+dfsg-1~), libpion-plugins-dbg (<< 5.0.7+dfsg-1~)' || dh_strip

get-orig-source:
	uscan --watchfile $(CURDIR)/debian/watch.get-orig-source --verbose --force-download --no-symlink --destdir ..

## pion 5.0.7+dfsg

=== CMakeLists.txt ===
# ---------------------------------------------------------------------
# pion:  a Boost C++ framework for building lightweight HTTP interfaces
# ---------------------------------------------------------------------
# Copyright (C) 2013 Splunk Inc.  (https://github.com/splunk/pion)
#
# Distributed under the Boost Software License, Version 1.0.
# See http://www.boost.org/LICENSE_1_0.txt
# ---------------------------------------------------------------------

cmake_minimum_required(VERSION 2.8.10 FATAL_ERROR)
set(PROJECT_NAME pion_solution)
project(${PROJECT_NAME} CXX C)

if( CMAKE_SOURCE_DIR STREQUAL CMAKE_BINARY_DIR)
  message(FATAL_ERROR "In-source builds are not allowed. CMake would overwrite "
"the files distributed with LLVM. Please create a directory and run cmake "
"from there, passing the path to this source directory as the last argument. "
"This process created the file `CMakeCache.txt' and the directory "
"`CMakeFiles'. Please delete them.")
endif()

#-------------------------------------------------
# prepare folders var's
#-------------------------------------------------
# src root path
set(PION_SRC_ROOT ${PROJECT_SOURCE_DIR} CACHE PATH "Pion source root")
# binary output by default
set(COMMON_BIN_PATH ${CMAKE_BINARY_DIR}/Bin)
set(LIBRARY_OUTPUT_PATH ${COMMON_BIN_PATH}/${CMAKE_BUILD_TYPE})
set(EXECUTABLE_OUTPUT_PATH ${COMMON_BIN_PATH}/${CMAKE_BUILD_TYPE})
# set where to find additional cmake modules if any
set(CMAKE_MODULE_PATH ${PION_SRC_ROOT}/cmake ${CMAKE_MODULE_PATH})

message("EXECUTABLE_OUTPUT_PATH = ${EXECUTABLE_OUTPUT_PATH}")

include(PionUtils)
pion_get_version("${PION_SRC_ROOT}" PION_V_MAJOR PION_V_MINOR PION_V_PATCH)
pion_update_compilation_opts()

set(PION_VERSION "${PION_V_MAJOR}.${PION_V_MINOR}.${PION_V_PATCH}" CACHE STRING "Pion version" FORCE)
message(">>> Building Pion version: ${PION_VERSION}")

#----------------------------------------------------------
# Configuration options block
#----------------------------------------------------------

# general
option(BUILD_SHARED_LIBS "Build Pion as shared library" ON)
option(BUILD_SPDY "Enable SPDY" OFF)
option(BUILD_UT "Enable Unit test" OFF)

# utils
option(BUILD_PIOND "Enable piond" ON)
option(BUILD_HELLOSERVER "Enable helloserver" ON)

# services
option(BUILD_ALLOWNOTHINGSERVICE "Enable AllowNothingService" ON)
option(BUILD_COOKIESERVICE "Enable CookieService" ON)
option(BUILD_ECHOSERVICE "Enable EchoService" ON)
option(BUILD_FILESERVICE "Enable FileService" ON)
option(BUILD_HELLOSERVICE "Enable HelloService" ON)
option(BUILD_LOGSERVICE "Enable LogService" ON)

# logging
option(USE_LOG4CPLUS "Use log4cplus" OFF)
option(USE_LOG4CXX "Use log4cxx" OFF)
option(USE_LOG4CPP "Use log4cpp" OFF)
option(DISABLE_LOGGING "Disable logging" ON)

#----------------------------------------------------------

# cleanup prefix lib for Unix-like OSes
set(CMAKE_SHARED_MODULE_PREFIX)

# install target to this folder by default
set(PION_BINARY_DIR ${PION_SRC_ROOT}/bin)
if(CMAKE_INSTALL_PREFIX_INITIALIZED_TO_DEFAULT)
    set(CMAKE_INSTALL_PREFIX "${PION_BINARY_DIR}" CACHE PATH "default install path" FORCE)
endif()

# make include globaly visible
set(PROJECT_WIDE_INCLUDE ${PION_SRC_ROOT}/include)
include_directories(${PROJECT_WIDE_INCLUDE})

find_package(Threads REQUIRED)

# TODO: need to handle this with option
set(Boost_USE_MULTITHREADED ON)
#set(Boost_USE_STATIC_LIBS ON)
set(Boost_USE_STATIC_RUNTIME OFF)

find_package(Boost COMPONENTS thread system filesystem regex unit_test_framework REQUIRED)
if (Boost_FOUND)
    # disable autolinking feature
    add_definitions(-DBOOST_ALL_NO_LIB)
    include_directories(${Boost_INCLUDE_DIR})
else()
    message(FATAL_ERROR "Boost >= 1.35 required to build Pion")
endif()

include(PionConfigure)

find_package(ZLIB)
if (ZLIB_FOUND)
    include_directories(${ZLIB_INCLUDE_DIRS})
    set(PION_HAVE_ZLIB 1)
else()
    if (BUILD_SPDY)
        message(FATAL_ERROR "zlib is mandatory required for SPDY support")
    endif()
endif()

find_package(BZip2)
if(BZIP2_FOUND)
    include_directories(${BZIP2_INCLUDE_DIR})
    set(PION_HAVE_BZLIB 1)
endif()

find_package(OpenSSL)
if(OPENSSL_FOUND)
    include_directories(${OPENSSL_INCLUDE_DIR})
    set(PION_HAVE_SSL 1)
endif()

if(USE_LOG4CPLUS)
    set(Log4Cplus_USE_STATIC_LIBS 1)
    find_package(Log4cplus)
    if (LOG4CPLUS_FOUND)
        include_directories(${LOG4CPLUS_INCLUDE_DIR})
        set(PION_USE_LOG4CPLUS 1)
    endif()
endif()

if(USE_LOG4CXX)
    message(FATAL_ERROR "log4cxx not supported")
    # TODO: find package and set(PION_USE_LOG4CXX 1)
endif()

if(USE_LOG4CPP)
    message(FATAL_ERROR "log4cpp not supported")
    # TODO: find package and set(PION_USE_LOG4CPP 1)
endif()

if (DISABLE_LOGGING)
    set(PION_DISABLE_LOGGING 1)
endif()

find_package(Doxygen)
if (DOXYGEN_FOUND)
    add_custom_target(doc ${DOXYGEN_EXECUTABLE} ${PROJECT_SOURCE_DIR}/doc/Doxyfile
        WORKING_DIRECTORY ${PROJECT_SOURCE_DIR})
endif()

configure_file(${PION_SRC_ROOT}/cmake/config.hpp.cmake ${COMMON_BIN_PATH}/pion/config.hpp)
include_directories(${COMMON_BIN_PATH})

# TODO: handle #pragma comment, which is hardcoded in config.hpp
# need to generate config.hpp by ourselfs
add_definitions(-DPION_CMAKE_BUILD)

#-------------------------------------------------
# enable TDD
#-------------------------------------------------
if(BUILD_UT)
    include(CTest)
    enable_testing()
    add_subdirectory(tests)
endif()

# here we add submodules
add_subdirectory(src)
add_subdirectory(services)
add_subdirectory(utils)

install(DIRECTORY ${PION_SRC_ROOT}/include/ DESTINATION include FILES_MATCHING PATTERN "*.hpp")
install(FILES ${COMMON_BIN_PATH}/pion/config.hpp DESTINATION include/pion/)

=== services/CMakeLists.txt ===
# ---------------------------------------------------------------------
# pion:  a Boost C++ framework for building lightweight HTTP interfaces
# ---------------------------------------------------------------------
# Copyright (C) 2013 Splunk Inc.  (https://github.com/splunk/pion)
#
# Distributed under the Boost Software License, Version 1.0.
# See http://www.boost.org/LICENSE_1_0.txt
# ---------------------------------------------------------------------

cmake_minimum_required(VERSION 2.8.10 FATAL_ERROR)

set(PROJECT_NAME services)
project(${PROJECT_NAME} CXX)

# get all *.cpp files from src to build target
file(GLOB SRC_FILES ${PROJECT_SOURCE_DIR}/*.cpp)

# build targets from each file
foreach(_file ${SRC_FILES})
    get_filename_component(_prj_name ${_file} NAME_WE)
    string(TOUPPER ${_prj_name} _prj_name_upper)
    message("BUILD_${_prj_name_upper} = ${BUILD_${_prj_name_upper}}")
    if (BUILD_${_prj_name_upper})
        add_library(${_prj_name} MODULE ${_file})
        target_link_libraries(${_prj_name} pion)
        install(TARGETS ${_prj_name}
            RUNTIME DESTINATION services
            LIBRARY DESTINATION services
            ARCHIVE DESTINATION services
            )
    endif()
endforeach()

=== tests/CMakeLists.txt ===
# ---------------------------------------------------------------------
# pion:  a Boost C++ framework for building lightweight HTTP interfaces
# ---------------------------------------------------------------------
# Copyright (C) 2013 Splunk Inc.  (https://github.com/splunk/pion)
#
# Distributed under the Boost Software License, Version 1.0.
# See http://www.boost.org/LICENSE_1_0.txt
# ---------------------------------------------------------------------

cmake_minimum_required(VERSION 2.8.10 FATAL_ERROR)

set(PROJECT_NAME piontests)
project(${PROJECT_NAME} CXX)

# add test plugins
add_subdirectory(plugins)

if (MSVC AND NOT CMAKE_CFG_INTDIR STREQUAL ".")
    # hack for msvc path substitution
    set(PLUGIN_PATH ${COMMON_BIN_PATH}/${CMAKE_CFG_INTDIR})
else()
    set(PLUGIN_PATH ${EXECUTABLE_OUTPUT_PATH})
endif()

message("PLUGIN_PATH = ${PLUGIN_PATH}; EXECUTABLE_OUTPUT_PATH = ${EXECUTABLE_OUTPUT_PATH}")

add_custom_target(prepare_path
    COMMAND cmake -DPION_PLUGIN_PATH=${PLUGIN_PATH} -DPION_SRC_ROOT=${PION_SRC_ROOT} -P ${PION_SRC_ROOT}/cmake/GenTestInclude.cmake
)

include_directories(${PLUGIN_PATH})
include_directories(${PROJECT_SOURCE_DIR})

# get all *.cpp files from src to build target
file(GLOB SRC_FILES ${PROJECT_SOURCE_DIR}/*.cpp)

add_definitions(-DBOOST_TEST_DYN_LINK)

# build target
add_executable(${PROJECT_NAME} ${SRC_FILES})
target_link_libraries(${PROJECT_NAME} ${Boost_LIBRARIES} pion ${CMAKE_THREAD_LIBS_INIT})
add_dependencies(${PROJECT_NAME} prepare_path)

add_test(NAME pion_test WORKING_DIRECTORY ${EXECUTABLE_OUTPUT_PATH} COMMAND ${PROJECT_NAME})

install(TARGETS ${PROJECT_NAME}
    RUNTIME DESTINATION bin
    LIBRARY DESTINATION tests
    ARCHIVE DESTINATION tests
    )

=== utils/CMakeLists.txt ===
# ---------------------------------------------------------------------
# pion:  a Boost C++ framework for building lightweight HTTP interfaces
# ---------------------------------------------------------------------
# Copyright (C) 2013 Splunk Inc.  (https://github.com/splunk/pion)
#
# Distributed under the Boost Software License, Version 1.0.
# See http://www.boost.org/LICENSE_1_0.txt
# ---------------------------------------------------------------------

cmake_minimum_required(VERSION 2.8.10 FATAL_ERROR)

set(PROJECT_NAME utils)
project(${PROJECT_NAME} CXX)

message("BUILD_PIOND = ${BUILD_PIOND}")
if (BUILD_PIOND)
    set(PIOND_SRC_FILES piond.cpp)
    add_executable(piond ${PIOND_SRC_FILES})
    target_link_libraries(piond pion ${CMAKE_THREAD_LIBS_INIT})
    install(TARGETS piond
        RUNTIME DESTINATION bin
        LIBRARY DESTINATION lib
        ARCHIVE DESTINATION lib
    )
endif()

message("BUILD_HELLOSERVER = ${BUILD_HELLOSERVER}")
if (BUILD_HELLOSERVER)
    set(HELLOSRVR_SRC_FILES helloserver.cpp)
    add_executable(helloserver ${HELLOSRVR_SRC_FILES})
    target_link_libraries(helloserver pion ${CMAKE_THREAD_LIBS_INIT})
    install(TARGETS helloserver
        RUNTIME DESTINATION bin
        LIBRARY DESTINATION lib
        ARCHIVE DESTINATION lib
    )
endif()

=== tests/plugins/CMakeLists.txt ===
# ---------------------------------------------------------------------
# pion:  a Boost C++ framework for building lightweight HTTP interfaces
# ---------------------------------------------------------------------
# Copyright (C) 2013 Splunk Inc.  (https://github.com/splunk/pion)
#
# Distributed under the Boost Software License, Version 1.0.
# See http://www.boost.org/LICENSE_1_0.txt
# ---------------------------------------------------------------------

cmake_minimum_required(VERSION 2.8.10 FATAL_ERROR)

set(PROJECT_NAME plugins)
project(${PROJECT_NAME} CXX)

include_directories(${PROJECT_SOURCE_DIR})

# get all *.cpp files from src to build target
file(GLOB SRC_FILES ${PROJECT_SOURCE_DIR}/*.cpp)

# build targets from each file
foreach(_file ${SRC_FILES})
    get_filename_component(_prj_name ${_file} NAME_WE)
    set(_hdr_file "${PROJECT_SOURCE_DIR}/${_prj_name}.hpp")
    add_library(${_prj_name} MODULE ${_file} ${_hdr_file})
    target_link_libraries(${_prj_name} pion)
    install(TARGETS ${_prj_name}
        RUNTIME DESTINATION tests
        LIBRARY DESTINATION tests
        ARCHIVE DESTINATION tests
        )

endforeach()

=== debian/changelog ===
pion (5.0.7+dfsg-4) unstable; urgency=medium

  * Fix FTBFS, do not let arch-dependent actions leak to arch-independent
    installation target, patch from Santiago Vila (Closes: #848860)

 -- Roberto C. Sanchez <roberto@connexer.com>  Fri, 23 Dec 2016 22:10:37 -0500

pion (5.0.7+dfsg-3) unstable; urgency=medium

  * Fix FTBFS, build unit tests unoptimized on arm64 to work around a
    spurious null pointer dereference (Closes: #847133)

 -- Roberto C. Sanchez <roberto@connexer.com>  Fri, 09 Dec 2016 23:51:24 -0500

pion (5.0.7+dfsg-2) unstable; urgency=medium

  * Fix FTBFS with gcc6 (narrowing conversion), thanks to Graham Inggs
    for the patch (Closes: #846573)

 -- Roberto C. Sanchez <roberto@connexer.com>  Sun, 04 Dec 2016 23:15:54 -0500

pion (5.0.7+dfsg-1) unstable; urgency=medium

  * New upstream release (Closes: #825099, #828504)
  * Update to Standards-Version 3.9.8 (no changes)
  * Fix FTBFS with gcc6, thanks to Graham Inggs for the patch
    (Closes: #811849)
  * Update to debhelper compatibility level 9 (rework debian/rules)
  * Switch to generated -dbg package

 -- Roberto C. Sanchez <roberto@connexer.com>  Thu, 01 Dec 2016 00:29:06 -0500

=== debian/control ===
Source: pion
Priority: extra
Maintainer: Athena Capital Research <acr-debian@athenacr.com>
Uploaders: Roberto C. Sanchez <roberto@connexer.com>
Build-Depends: debhelper (>= 9),
 dh-autoreconf | debhelper (>= 9.20160403~),
 autotools-dev,
 autoconf,
 automake,
 libssl-dev,
 libboost-dev (>= 1.35),
 libboost-thread-dev (>= 1.35),
 libboost-iostreams-dev (>= 1.35),
 libboost-system-dev (>= 1.35),
 libboost-filesystem-dev (>= 1.35),
 libboost-signals-dev (>= 1.35),
 libboost-test-dev (>= 1.35),
 chrpath,
 zlib1g-dev,
 doxygen,
 perl,
 libbz2-dev,
 libxml2-dev,
 libpcap-dev,
 libtool,
 ruby,
 cmake,
 pkg-config,
 liblog4cpp5-dev
Standards-Version: 3.9.8
Section: libs
Homepage: https://github.com/splunk/pion
Vcs-Browser: https://github.com/splunk/pion
Vcs-Git: https://github.com/splunk/pion.git

Package: libpion-dev
Section: libdevel
Architecture: any
Depends: libpion-5.0 (= ${binary:Version}),
 libpion-plugins (= ${binary:Version}),
 liblog4cpp5-dev,
 libssl-dev,
 ${shlibs:Depends},
 ${misc:Depends}
Conflicts: libpion-net-dev
Suggests: libpion-doc
Description: lightweight HTTP interface library - development files
 pion is not intended to implement yet another web server, but to
 provide HTTP(S) functionality to new or existing C++ applications. If
 you're looking for a full-featured server application, check out Apache
 or lighttpd. If you're working on a Boost C++ application and would just
 like to use HTTP to provide a simple user interface or interact with
 run-time data, then pion is a clean and simple solution.
 .
 Pion Network Library uses the Boost and asio libraries for multi-threading
 and asynchronous I/O. This allows servers implemented using pion to
 handle many thousands of connections simultaneously with a single physical
 server.
 .
 pion also supports server-side SSL & TLS encryption when built with
 the OpenSSL library (which the Debian package is).
 .
 This package includes the pion development files.

Package: libpion-plugins
Architecture: any
Depends: libpion-5.0 (= ${binary:Version}),
 ${shlibs:Depends},
 ${misc:Depends}
Conflicts: libpion-net-plugins
Description: lightweight HTTP interface library - plugins
 pion is not intended to implement yet another web server, but to
 provide HTTP(S) functionality to new or existing C++ applications. If
 you're looking for a full-featured server application, check out Apache
 or lighttpd. If you're working on a Boost C++ application and would just
 like to use HTTP to provide a simple user interface or interact with
 run-time data, then pion is a clean and simple solution.
 .
 Pion Network Library uses the Boost and asio libraries for multi-threading
 and asynchronous I/O. This allows servers implemented using pion to
 handle many thousands of connections simultaneously with a single physical
 server.
 .
 pion also supports server-side SSL & TLS encryption when built with
 the OpenSSL library (which the Debian package is).
 .
 This package includes the pion plugins.

Package: libpion-5.0
Architecture: any
Depends: ${shlibs:Depends},
 ${misc:Depends}
Description: lightweight HTTP interface library - runtime files
 pion is not intended to implement yet another web server, but to
 provide HTTP(S) functionality to new or existing C++ applications. If
 you're looking for a full-featured server application, check out Apache
 or lighttpd. If you're working on a Boost C++ application and would just
 like to use HTTP to provide a simple user interface or interact with
 run-time data, then pion is a clean and simple solution.
 .
 Pion Network Library uses the Boost and asio libraries for multi-threading
 and asynchronous I/O. This allows servers implemented using pion to
 handle many thousands of connections simultaneously with a single physical
 server.
 .
 pion also supports server-side SSL & TLS encryption when built with
 the OpenSSL library (which the Debian package is).
 .
 This package includes the pion runtime files.

Package: libpion-doc
Section: doc
Architecture: all
Depends: libjs-jquery, ${misc:Depends}
Description: lightweight HTTP interface library - documentation
 pion is not intended to implement yet another web server, but to
 provide HTTP(S) functionality to new or existing C++ applications. If
 you're looking for a full-featured server application, check out Apache
 or lighttpd. If you're working on a Boost C++ application and would just
 like to use HTTP to provide a simple user interface or interact with
 run-time data, then pion is a clean and simple solution.
 .
 Pion Network Library uses the Boost and asio libraries for multi-threading
 and asynchronous I/O. This allows servers implemented using pion to
 handle many thousands of connections simultaneously with a single physical
 server.
 .
 pion also supports server-side SSL & TLS encryption when built with
 the OpenSSL library (which the Debian package is).
 .
 This package includes the pion documentation files.

=== debian/watch ===
version=3

opts="dversionmangle=s/\+dfsg\d*//,filenamemangle=s/(?:[^\d\.]*)?v?(\d[\d\.]*)\.tar\.gz/pion-$1.tar.gz/" \
    https://github.com/splunk/pion/tags (?:[^\d\.]*)?v?(\d[\d\.]*)\.tar\.gz \
    debian debian/repack.sh
